<?php
//定数とか関数とかまとめファイル
//各ファイルで最初に呼び出すこと

//コンフィグファイル名
define("CONFIG_FILE","config.php");
//コンフィグファイルを読み込む
include(CONFIG_FILE);
//テンプレコンフィグファイル名
define("TPLCONFIG_FILE","tpl_config.php");
//テンプレコンフィグファイルを読み込む
include(TPLCONFIG_FILE);
//DBファイルを読み込む
include("db_config.php");
//DB設定がされてなければエラー
if(empty($conf_db_name) or empty($conf_db_host) or empty($conf_db_username) or empty($conf_db_pass)){
	echo "DB設定が完了していません。<br />設定ファイルを編集してください。";
	exit;
}
//DB設定定義
//DB名
define("DB_NAME" , $conf_db_name);
//ホスト名
define("DB_HOST" , $conf_db_host);
//ユーザー名
define("DB_USERNAME" , $conf_db_username);
//パス
define("DB_PASS" , $conf_db_pass);

//adminページファイル名
define("QCR_FILENAME",'qc_admin.php');
//loginページファイル名
define("LOGIN_PAGE","qc_login.php");
// USERIDの長さ設定
define("USERID_LEN", 8);

//クイックコメントのインストールディレクトリ
$home_url = (!empty($conf_home_url))?$conf_home_url:"http://localhost/";

//拍手を連続送信できる回数。デフォルト10回
$click_limit = (!empty($conf_click_limit) and is_numeric($conf_click_limit))?$conf_click_limit:10;

//コメントの最大文字数。1000字以上が設定されていたら1000字に制限。
$text_max = (!empty($conf_text_max) and is_numeric($conf_text_max) and $conf_text_max<=1000)?$conf_text_max:1000;

//コメント連続送信制限の解除期限
//　現在時刻より何秒後に解除するかを設定。
//　未設定の場合、本日24時までに
$timeout_date = $conf_timeout_date;

//結果画面のグラフの高さ(px)
$graph_height = 200;

//一度に表示するコメント件数
$recent = (!empty($conf_recent) and is_numeric($conf_recent)) ? $conf_recent : 20;

//1件全体を囲うタグ
$tag_comment_f = (!empty($conf_tag_comment_f))?$conf_tag_comment_f:'';
$tag_comment_r = (!empty($conf_tag_comment_r))?$conf_tag_comment_r:'';
//コメント本文を囲うタグ
$tag_text_f = (!empty($conf_tag_text_f))?$conf_tag_text_f:'';
$tag_text_r = (!empty($conf_tag_text_r))?$conf_tag_text_r:'';
//レスを囲うタグ
$tag_res_f = (!empty($conf_tag_res_f))?$conf_tag_res_f:'';
$tag_res_r = (!empty($conf_tag_res_r))?$conf_tag_res_r:'';


//利用中のテンプレートファイル名
$tpl_filename = (!empty($conf_tpl_filename))?$conf_tpl_filename:'index.html';
//利用中のフォームテンプレートファイル名
$tpl_form_filename = (!empty($conf_tpl_form_filename))?$conf_tpl_form_filename:'form.html';

//拍手画面の注意文言
$qc_default_msg = 'メッセージはこちらまで。';
$textarea_info = '全角'.$text_max.'文字までです。空行は削除されます。';
$name_info = '全角16文字までです。なくても送信できます。';

//管理モード
$admin_mode = true;
//デモモード
$demo_mode = false;

//ディレクトリ定義
//画像のディレクトリ
define("IMAGE_DIR","./image/");
//テンプレートのディレクトリ
define("TPL_DIR","./tpl/");

//テーブル名
//投稿コメントテーブル
define("QC_POST" , $table_prefix."qc_post");
//クリックカウントテーブル
define("QC_CLICK_COUNT" , $table_prefix."qc_click_count");
//クリックユーザーテーブル
define("QC_USER_COUNT" , $table_prefix."qc_user_count");
//レスポンステーブル
define("QC_RES" , $table_prefix."qc_res");

$deny_ng_split = false;
	
//NGリスト読み込み
function ng_check($word,$type){
	//NGワードが区切られていたときの文字指定
	global $deny_ng_split;
	$ng_split = "(~|=|:|-|\.|\/|\+|\||\^||｜|＊|／|＼|。|、|＝|＾|；|：)";
	$ngfile = @file("./data/ng/".$type.".ini",FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES|FILE_TEXT);
	$word = mb_convert_kana(mb_convert_encoding(urldecode($word), "UTF-8", "auto"),"aKV");
	if(!empty($ngfile)){
		foreach($ngfile as $v){
			$w = mb_convert_kana(trim($v),"aKV");
			$ng = ($type=="post")?"/".$w."/i":"/^".$w."$/i";
			if(preg_match($ng,$word)){
			//echo "NG!\n";
				return true;
			}elseif($deny_ng_split and ($type=="name" or $type=="post")){
				//NGワードが区切られていたときに判定する
				$ng = "";
				for ($i = 0; $i < mb_strlen($w,'UTF-8'); $i++) {
					$c = mb_substr($w, $i, 1,'UTF-8');
					if($i>0){
						$ng .= $ng_split;
					}
					$ng .= $c;
				}
				$ng = ($type=="post")?"/".$ng."/i":"/^".$ng."$/i";
				if(preg_match($ng,$word)){
					//echo "NG!\n";
					return true;
				}
			}
		}
	}
	return false;
}

//メニュー出力
function get_menu_bar($now,$mobile,$sid){
	$nowtab = array();
	if(!empty($now)){
		$nowtab[$now] = 'class="now"';
	}else{
		$nowtab['top'] = 'class="now"';
	}
	if(!$mobile){
		echo '<div id="menu">';
			echo '<ul>';
				echo '<li '.$nowtab['top'].'><a href="./'.QCR_FILENAME.'">top</a></li>';
				echo '<li '.$nowtab['nores'].'><a href="./'.QCR_FILENAME.'?res=0"><span class="title-no-res">未レス</span>のコメント</a></li>';
				echo '<li '.$nowtab['res'].'><a href="./'.QCR_FILENAME.'?res=1"><span class="title-res">レス済み</span>のコメント</a></li>';
				echo '<li '.$nowtab['fav'].'><a href="./'.QCR_FILENAME.'?fav=1"><span class="title-fav">お気に入り</span>コメント</a></li>';
				echo '<li '.$nowtab['manual'].'><a href="./manual.php"><span class="title-manual">マニュアル</span></a></li>';
				echo '<li '.$nowtab['img'].'><a href="./manage_images.php">画像管理</a></li>';
				echo '<li '.$nowtab['tpl'].'><a href="./edit_tpl.php">テンプレート</a></li>';
				echo '<li '.$nowtab['conf'].'><a href="./edit_config.php">設定</a></li>';
			echo '</ul>';
		echo '</div>';
	}else{
		echo '<a href="./'.QCR_FILENAME.'?sid='.$sid.'" accesskey="0">[0]top</a> ';
		echo '<a href="./'.QCR_FILENAME.'?sid='.$sid.'&res=0" accesskey="1">[1]未ﾚｽ</a> ';
		echo '<a href="./'.QCR_FILENAME.'?sid='.$sid.'&res=1" accesskey="2">[2]ﾚｽ済</a> ';
		echo '<a href="./'.QCR_FILENAME.'?sid='.$sid.'&fav=1" accesskey="3">[3]☆</a> ';
		echo '<hr size="1" noshade class="comment-line" color="#E0E0E0" />';
	}
}
function logout_btn(){
	global $qc_pass;
	if(!empty($qc_pass)){
		echo '<form action="../'.LOGIN_PAGE.'" method="POST" name="logout-form" id="logout-form">';
		echo '<input type="submit" value="ログアウト" name="logout" class="submit" id="logout" />';
		echo '</form>';
	}
}


function mobile_check($ua){
	if(substr_count($ua,"DoCoMo") > 0 or substr_count($ua,"UP.Browser") > 0 or substr_count($ua,"SoftBank") > 0){
		return true;
	}else{
		return false;
	}
}
//サニタイズ
function sa($str){
	$str = htmlspecialchars($str, ENT_QUOTES, "UTF-8");
	return addslashes($str);
}

//pg_fetch_allに相当する関数
function mysql_fetch_all($query, $kind = 'assoc') {
    $result = array();
    $kind = ($kind === 'assoc') ? $kind : 'row';
    eval('while(@$r = mysql_fetch_'.$kind.'($query)) array_push($result, $r);');
    return $result;
}

//日を取得
function getDay($day){
    $now = time();
    return mktime(date("H",$now),date("i",$now),date("s",$now),date("m",$now),date("d",$now)+$day,date("Y",$now));
}
//URLかどうかチェック
function url_check($url){
	if (preg_match('/^(http|HTTP|ftp)(s|S)?:\/\/+([A-Za-z0-9]|-|_)+\.([A-Za-z0-9]|-|_)/',$url))	{
		return true;
	}
	else{
		return false;
	}
}

//テーブルがあるかチェックし、無い場合は作成する
function qc_table_exists($cn){
	// テーブルリストの取得
	$rs = mysql_list_tables(DB_NAME,$cn);
	
	// 結果セットの1レコード分を添え字配列として取得する
	while($arr_row = mysql_fetch_row($rs))
	{
		if(in_array( QC_POST ,$arr_row)){
			$qc_post_exists = true;
		}elseif(in_array( QC_CLICK_COUNT ,$arr_row)){
			$qc_click_count_exists = true;
		}elseif(in_array( QC_USER_COUNT ,$arr_row)){
			$qc_user_count_exists = true;
		}elseif(in_array( QC_RES ,$arr_row)){
			$qc_res_exists = true;
		}
	}
	//コメントテーブル作成
	if(!$qc_post_exists){
		$sql = "CREATE TABLE `".DB_NAME."`.`".QC_POST."` (
		`id` INT UNSIGNED NOT NULL  AUTO_INCREMENT ,
		`user_id` VARCHAR( ".USERID_LEN." ) NOT NULL ,
		`name` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci ,
		`comment` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
		`ip` VARCHAR( 30 ) NOT NULL ,
		`pos_id` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
		`fav` INT( 1 ) UNSIGNED NOT NULL ,
		`res` INT( 1 ) UNSIGNED NOT NULL ,
		`date` TIMESTAMP  DEFAULT CURRENT_TIMESTAMP ,
		PRIMARY KEY ( `id` )
		) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_general_ci";
		mysql_query($sql,$cn) or die("コメントテーブルが作成できません。"); 
	}
	//クリックカウントテーブルの作成
	if(!$qc_click_count_exists){
		$sql = "CREATE TABLE `".DB_NAME."`.`".QC_CLICK_COUNT."` (
			`date` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
			`0` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`1` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`2` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`3` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`4` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`5` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`6` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`7` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`8` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`9` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`10` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`11` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`12` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`13` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`14` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`15` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`16` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`17` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`18` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`19` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`20` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`21` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`22` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`23` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`last_update` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ,
			PRIMARY KEY ( `date` )
			) ENGINE = MYISAM";
		mysql_query($sql,$cn) or die("クリックカウントテーブルが作成できません。"); 
		//初期値設定
		$sql = "insert into `".DB_NAME."`.`".QC_CLICK_COUNT."` (date,`0`,`1`,`2`,`3`,`4`,`5`,`6`,`7`,`8`,`9`,`10`,`11`,`12`,`13`,`14`,`15`,`16`,`17`,`18`,`19`,`20`,`21`,`22`,`23`) values('".date("Y-m-d")."',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)";
		mysql_query($sql,$cn) or die("データが初期化できません。"); 
	}
	//クリックユーザーテーブルの作成
	if(!$qc_user_count_exists){
		$sql = "CREATE TABLE `".DB_NAME."`.`".QC_USER_COUNT."` (
			`date` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
			`0` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`1` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`2` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`3` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`4` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`5` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`6` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`7` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`8` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`9` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`10` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`11` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`12` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`13` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`14` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`15` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`16` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`17` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`18` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`19` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`20` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`21` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`22` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`23` INT UNSIGNED NOT NULL DEFAULT '0' ,
			`last_update` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ,
			PRIMARY KEY ( `date` )
			) ENGINE = MYISAM";
		mysql_query($sql,$cn) or die("ユーザーカウントテーブルが作成できません。"); 
		//初期値設定
		$sql = "insert into `".DB_NAME."`.`".QC_USER_COUNT."` (date,`0`,`1`,`2`,`3`,`4`,`5`,`6`,`7`,`8`,`9`,`10`,`11`,`12`,`13`,`14`,`15`,`16`,`17`,`18`,`19`,`20`,`21`,`22`,`23`) values('".date("Y-m-d")."',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)";
		mysql_query($sql,$cn) or die("データが初期化できません。"); 
	}
	//レスポンステーブルの作成
	if(!$qc_res_exists){
		$sql = "CREATE TABLE `".DB_NAME."`.`".QC_RES."` (`id` INT NOT NULL  AUTO_INCREMENT,
			`comment_id` INT UNSIGNED NOT NULL,
			`response` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
			`date` TIMESTAMP on update CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
			PRIMARY KEY (`id`)) ENGINE = MyISAM";
		mysql_query($sql,$cn) or die("レステーブルが作成できません。"); 
	}
}

define("COPY_LIGHT",'<div id="copyright">QuickComment | PrivateMoon</div>');
?>